#include <QtGlobal>
#include <QtWidgets>
#include <QWebEngineView>
#include "printhandler.h"
#include "timetableprintform.h"

TimetablePrintForm::TimetablePrintForm(QWidget *parent): QDialog(parent){
	pbPrintPreviewFull=new QPushButton(tr("Preview"));
	pbClose=new QPushButton(tr("Close"));


	QHBoxLayout* previewPrintClose=new QHBoxLayout;
	previewPrintClose->addWidget(pbPrintPreviewFull);
	previewPrintClose->addWidget(pbClose);

	setLayout(previewPrintClose);

	connect(pbPrintPreviewFull, SIGNAL(clicked()), this, SLOT(printPreview()));
	connect(pbClose, SIGNAL(clicked()), this, SLOT(close()));

	viewPreview2 = new QWebEngineView(this); //notVisible. But must stay alive for printing.
	viewPreview2->hide();

	connect(viewPreview2, SIGNAL(loadFinished(bool)), this, SLOT(printPreviewReadyToStart(bool)));

	//debug only
	connect(viewPreview2, SIGNAL(loadStarted()), this, SLOT(printPreviewLoadStarted()));
	connect(viewPreview2, SIGNAL(loadProgress(int)), this, SLOT(printPreviewLoadProgress(int)));
}

TimetablePrintForm::~TimetablePrintForm(){
}


void TimetablePrintForm::printPreview(){
	this->setEnabled(false);
	if(viewPreview2==NULL){
		qDebug("NULL");
	} else {
		qDebug("Not NULL");
	}
	viewPreview2->setHtml("testtesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttest");
}

void TimetablePrintForm::printPreviewReadyToStart(bool ok){
	if(!ok){
		QMessageBox::warning(this, tr("Warning"), tr("Critical bug. Preview not finished."));
	}
	else {
		PrintHandler handler;
		handler.setView(viewPreview2);

		handler.printPreview();
	}
	this->setEnabled(true);
}


void TimetablePrintForm::printPreviewLoadStarted(){
	qDebug("printPreviewLoadStarted");
}

void TimetablePrintForm::printPreviewLoadProgress(int progress){
	qDebug("printPreviewLoadProgress");
	qDebug(qPrintable(QString::number(progress)));
}

